# TODO: for file configurations
from dataclasses import dataclass


@dataclass
class Configuration:
    config_id: str
    filename: str
    first_key: str | None
    second_key: str | None
    id_key: str
    identifiers_key: str
    type_cfg: str
    path: str
    on_off_field: str
    on_integration: None | str
    off_integration: str


@dataclass
class ConfigRestoreState:
    config_id: str
    filename: str
    first_key: str | None
    second_key: str | None
    id_key: str
    state: str
    attr_id: str
    identifiers_key: str
    type_cfg: str
    path: str
    on_off_field: str
    on_integration: None | str
    off_integration: str


@dataclass
class ConfigurationFile:
    configurations: list[Configuration]
    automations_cfg: list[Configuration]
    config_restore_state: ConfigRestoreState
